//	ReverseParagraph
//	www.pictrix.jp	Masayuki Umezawa
//	10.08.09

var CR = String.fromCharCode( 13 );
var SR = String.fromCharCode( 3 );

if ( app.documents.length  && app.activeDocument.textFrames.length  && 
	app.activeDocument.selection.length ){ main( ); }

function main( )
{
	var	docRef		= app.activeDocument;
	var	selObj		= docRef.selection;
	var	Obj			= new Array();
	var	i, cnt = 0;

	for ( i = 0; i < selObj.length; i++){
		if ( selObj[ i ].typename == "TextFrame" ){
			Obj[ cnt++ ] = selObj[ i ];
		}
	}
	selObj = null;

	for ( i = 0; i < cnt; i++ ){
		engine( Obj[ i ] );
	}
}


function engine( obj )
{
	var	i, j, tr, newTx;

	if ( obj.paragraphs.length < 2 ) return;

	delCr( obj );
	newTx = obj.layer.textFrames.add(  );
	for ( i = obj.paragraphs.length - 1; i >= 0; i-- ){
		tr = obj.paragraphs[ i ];
		if ( tr.length ){
			tr.move( newTx, ElementPlacement.INSIDE );
			newTx.textRange.characters.add( CR );
		}
		else{
			tr.characters.add( " " );
			tr.move( newTx, ElementPlacement.INSIDE );
			newTx.textRange.characters.add( CR );
			j = newTx.textRange.characters.length - 2;
			newTx.textRanges[ j ].remove( );
		}
	}
	obj.textRange.remove( );
	newTx.textRange.move( obj, ElementPlacement.INSIDE );
	newTx.remove( );
	delCr( obj );
}


function delCr ( obj )
{
	var n;
	var ch = obj.textRange.characters;

	n = ch.length -1;
	while ( ch[ n ].contents  == CR || ch[ n ].contents  == SR ){
		ch[ n ].remove( );
		n = ch.length -1;
	}
}




